using BusCommPracticeConsoleApp.Models;

namespace BusCommPracticeConsoleApp.CANs
{
    public class CANBus
    {
        private readonly List<CANNode> _nodes = new List<CANNode>();
        private CanFrame _currentFrame = null;

        public void AddNode(CANNode node)
        {
            _nodes.Add(node);
            node.ConnectToBus(this);
        }

        public void SendFrame(CANNode sender, CanFrame frame)
        {
            if (_currentFrame != null && frame.ID >= _currentFrame.ID)
            {
                Console.WriteLine("Already higher priority frame is used.");
                return;
            }

            _currentFrame = frame;
            Console.WriteLine($"{sender.Name} node send the frame{Environment.NewLine}{frame}");
        }

        public void CompleteTransmission()
        {
            if (_currentFrame == null)
                return;

            Console.WriteLine($"Send 0x{_currentFrame.ID.ToString("X8")} frame complete.");
            _currentFrame = null;
        }
    }
}