namespace BusCommPracticeConsoleApp.CANs
{
    public class CANNode
    {
        public string Name { get; set; }
        private CANBus _bus;

        public CANNode(string name)
        {
            Name = name;
        }

        public void ConnectToBus(CANBus bus)
        {
            _bus = bus;
        }

        public void SendMessage(uint id, byte[] data)
        {
            var frame = new CanFrame(id, false, data);
            _bus.SendFrame(this, frame);
        }

        public void ReceiveFrame(CanFrame frame)
        {
            if (frame.CRC != frame.CRC)
                Console.WriteLine("<{Name}> node CRC check error!");
        }

        public void AcknowledgeFrame()
        {
            Console.WriteLine($"<{Name}> node acknowledged.");
        }
    }
}