
namespace BusCommPracticeConsoleApp.Models
{
    public class MessageBus : IMessageBus
    {
        private readonly List<Action<string>> _subscribers = new List<Action<string>>();

        public void Publish(string message)
        {
            foreach (var subscriber in _subscribers)
            {
                subscriber(message);
            }
        }

        public void Subscribe(Action<string> subscriber)
        {
            _subscribers.Add(subscriber);
        }

        public void Unsubscribe(Action<string> subscriber)
        {
            _subscribers.Remove(subscriber);
        }
    }
}