﻿using System.Text;
using BusCommPracticeConsoleApp.CANs;
using BusCommPracticeConsoleApp.Models;

namespace BusCommPracticeConsoleApp;

class Program
{
    static void Main(string[] args)
    {
        /**********************
            MESSAGE BUS
        **********************/

        // IMessageBus messageBus1= new MessageBus();
        // IMessageBus messageBus2= new MessageBus();

        // var subscriber1 = new Subscriber(messageBus1, "Sub1");
        // var subscriber2 = new Subscriber(messageBus1, "Sub2");
        // var subscriber3 = new Subscriber(messageBus2, "Sub3");

        // var publisher1 = new Publisher(messageBus1);
        // var publisher2 = new Publisher(messageBus2);

        // publisher1.SendMessage("Hello, Bus!");
        // publisher1.SendMessage("I'm publisher 1");

        // publisher2.SendMessage("Hello, Bus!");
        // publisher2.SendMessage("I'm publisher 2");

        
        /**********************
            CAN BUS
        **********************/
        var bus = new CANBus();
        
        var nodeA = new CANNode("NodeA");
        var nodeB = new CANNode("NodeB");
        var nodeC = new CANNode("NodeC");

        bus.AddNode(nodeA);
        bus.AddNode(nodeB);
        bus.AddNode(nodeC);

        nodeA.SendMessage(0x1ABCDEFF, Encoding.UTF8.GetBytes("PHK"));
        nodeB.SendMessage(0x0123F321, new byte[] { 0x55, 0x66, 0x77, 0x88 });

        bus.CompleteTransmission();

        Thread.Sleep(1000);
        nodeC.SendMessage(0x12345678, new byte[] { 0x99, 0xAA, 0xBB, 0xCC });
        bus.CompleteTransmission();

        Console.ReadLine();
    }
}
